{ ͸
                               Multitasking                            
                         (c)Lion, Samara 1993-1995                     
  ;

  If you modify the source, keep this text without changes.
  If you use something from this source  in  your  program,
remember say 'thanks' to me in  Help/About  or other place,
where you writes your name.
                                            Lion Rokanidi.

  ᫨    室, ࠭   
⥪  .
  ᫨  ᯮ -  ⮣ 室  ᢮
ணࠬ,   ᪠  'ᯠᨡ'   Help/About,
  㣮 ,    ᢮ .
                                             .
}

{$A+,B-,D-,E-,F-,G-,I-,L-,N-,P-,Q-,R-,S-,T-,V-,X-,Y-}
{$M 8192,0,655360}
{ $Define DEBUG if you really want it }

Unit MTasking;

INTERFACE

Uses Crt, Dos;

Const
{$IfDef DEBUG}  NumTimer  = $60;
{$Else  }       NumTimer  = $08;
{$EndIf }

Type
    TaskProc = Procedure;
    TTaskID  = longint;
    TTaskInd = byte;


Procedure TaskInit(Max:TTaskInd; Time:word);

Procedure TaskTerm;

Function TaskExec(Task:TaskProc; StackSize:word):TTaskID;

Procedure TaskStop(ID:TTaskID);

Procedure TaskFreeze;

Procedure TaskMelt;


Function GetTaskNum:TTaskInd;

Function GetTaskID:TTaskID;

Procedure TaskEnter;  InLine($9C/$FA);  { pushf; cli }
Procedure TaskLeave;  InLine($9D);      { popf       }
Procedure TaskWait;   InLine($CD/NumTimer);

Procedure AllocStack(var Buf,Stack:pointer; Size:word);

IMPLEMENTATION

{$F+ (for TaskError)}

Type
    TTaskRec = record
                     Stack : pointer;
                     Buf   : pointer;
                     Size  : word;
                     ID    : TTaskID;
               end;          

Const
     TaskLim     = 255;
     TaskRecSize = SizeOf(TTaskRec);
     NormFlags   = $206;  { i=1, p=1 }

     Wait : boolean = False;

Type
    TTasks   = array [1..TaskLim] of TTaskRec;
    PTasks   = ^TTasks;

Var
   TaskAct, TaskNum, TaskMax   : TTaskInd;
   Tasks : PTasks;   TasksSize : word;

   TaskFreq : word;  TaskIDMax : TTaskID;

   OldTimer, SaveExit, SaveHeapError : pointer;


Type
    PDispStack = ^TDispStack;
    TDispStack = record
                       BP,ES,DS,DI,SI,DX,CX,BX,AX : word;
                       Start  : pointer;    Flags : word;
                       Finish : pointer;
                 end;

Procedure Dispatcher;  Assembler;        { ********* Don`t call ******** }
Asm                                      { Use only as interrupt handler }
   push ax;  push bx;  push cx;  push dx
   push si;  push di;  push ds;  push es
   push bp;            mov bl,TaskRecSize;
   mov ax,seg Tasks;   mov ds,ax;

   mov al,Wait;        cmp al,0;     jne @NonTimer
   pushf;  call dword ptr [OldTimer];    @NonTimer:
                                                  { DEBUG ********** DEBUG
   push ax;  push cx;   mov cx,100;  in  al,$61;
   @Sound :  xor al,2;  out $61,al;  push cx;  mov cx,10
   @Delay :  loop @Delay;            pop  cx;  loop @Sound
   pop cx;   pop ax                                 DEBUG ********** DEBUG }

   mov al,TaskAct;     mov cl,al;  lds si,Tasks;
   dec al;             mul bl
   add si,ax;          mov [si],sp
   add si,2;           mov [si],ss

   mov ax,seg Tasks;   mov ds,ax;  mov al,cl
   cmp al,TaskNum;  jl @NoOvr;
   xor al,al;          @NoOvr:     inc al

   mov TaskAct,al;     lds si,Tasks;
   dec al;             mul bl
   add si,ax;          mov sp,[si]
   add si,2;           mov ss,[si]

   pop bp
   pop es;   pop ds;   pop di;   pop si
   pop dx;   pop cx;   pop bx;   pop ax
   
   iret
end;

Procedure NullInt;  Far;  Assembler;
Asm
   iret
end;

Function TaskHeap(Size:word):integer;  Far;
begin
     TaskHeap:= 1
end;

Procedure TaskExit;  Far;
begin
     SetIntVec(NumTimer,OldTimer);
     ExitProc:=  SaveExit;
     HeapError:= SaveHeapError;
end;

Const
     teAlreadyInit     = 'Tasks already init';
     teWrongMax        = 'Wrong Max argument in TaskInit';
     teNotInit         = 'Tasks not init';
     teTermFromNotMain = 'Term attempt from subprocess';
     teNoMemForStack   = 'No memory for new task`s stack';
     teKillMain        = 'Cannot kill main process';
     teMaxOver         = 'Too many tasks';
     teStopFromSub     = 'Stop attempt from subprocess';
     teStopMain        = 'Cannot stop main process';
     teIDNotFound      = 'Task ID not found';

Procedure TaskError(Msg:string);
begin
     TaskExit;  GotoXY(1,2);  Write(Msg);  Halt(1)
end;

Procedure SetTimer(Freq:integer);
var Divisor : word;
begin
     Divisor:= 1190000 div Freq;
     Port[$43]:= $36;
     Port[$40]:= Divisor and $FF;
     Port[$40]:= Divisor shr 8;
end;

Procedure SetTimerDefault;
begin
     Port[$43]:= $36;
     Port[$40]:= 0;
     Port[$40]:= 0;
end;

Procedure TaskInit(Max:TTaskInd; Time:word);
begin
     TaskEnter;
     if Tasks <> Nil               then TaskError(teAlreadyInit);
     if not (Max in [2..TaskLim])  then TaskError(teWrongMax);

     TasksSize:= Max*TaskRecSize;   GetMem(Tasks,TasksSize);
     FillChar(Tasks^,TasksSize,0);  TaskMax:= Max;  TaskNum:= 1;  TaskAct:= 1;

     Tasks^[1].ID:= 0;              TaskIDMax:= 0;

     SaveExit:=      ExitProc;      ExitProc:=  @TaskExit;
     SaveHeapError:= HeapError;     HeapError:= @TaskHeap;

     GetIntVec(NumTimer,OldTimer);
     SetIntVec(NumTimer,@Dispatcher);

     TaskFreq:= Max * 1000 div Time;   SetTimer(TaskFreq);

     TaskLeave;
end;

Procedure TaskTerm;
begin
     Asm cli end;
     if Tasks = Nil then TaskError(teNotInit);
     if TaskAct<>1  then TaskError(teTermFromNotMain);  SetTimerDefault;
     TaskExit;      FreeMem(Tasks,TasksSize);  Tasks:= Nil;
     Asm sti end;
end;

Procedure AllocStack(var Buf,Stack:pointer; Size:word);
var SS,SP:word;
begin
     GetMem(Buf,Size); if Buf=Nil then TaskError(teNoMemForStack);
     SS:= Seg(Buf^);
     SP:= Ofs(Buf^);
     SS:= SS + SP div $10;
     SP:= SP mod $10;
     if SP > 0 then begin Inc(SP,Size - $10); Inc(SS) end else SP:= Size;
     Stack:= Ptr(SS,SP);
end;

Procedure TaskRemove(I:TTaskInd);
var R:TTaskRec;
begin
     R:= Tasks^[I];       Move(Tasks^[I+1],Tasks^[I],(TaskNum-I)*TaskRecSize);
     Tasks^[TaskNum]:= R; if I=TaskAct then TaskAct:= TaskNum;  Dec(TaskNum);
end;

Procedure TaskKill;  Far;  { Don`t call - only for using in Dispatcher }
begin
     TaskEnter;
     if Tasks = Nil then TaskError(teNotInit);
     if TaskAct = 1 then TaskError(teKillMain);
     TaskRemove(TaskAct);
     TaskLeave;  TaskWait
end;

Function TaskExec(Task:TaskProc; StackSize:word):TTaskID;
var St:PDispStack;
begin
     TaskEnter;  TaskExec:= 0;
     if Tasks   =    Nil then TaskError(teNotInit);
     if TaskNum>=TaskMax then TaskError(teMaxOver);
     Inc(TaskNum);  Inc(TaskIDMax);
     With Tasks^[TaskNum] do
          begin
               ID:= TaskIDMax;      if Buf<>Nil then FreeMem(Buf,Size);
               Size:= StackSize;    AllocStack(Buf,Stack,Size);
               St:= Ptr(Seg(Stack^),Ofs(Stack^)-SizeOf(St^));
               FillChar(St^,SizeOf(St^),0);
               With St^ do
                    begin
                         Start:=  @Task;      DS:= DSeg;  Flags:= NormFlags;
                         Finish:= @TaskKill;  ES:= DSeg;
                    end;
               Stack:= Ptr(Seg(Stack^),Ofs(Stack^)-SizeOf(St^));
               TaskExec:= ID
          end;
     TaskLeave
end;

Procedure TaskStop(ID:TTaskID);
var i:TTaskInd;
begin
     TaskEnter;
     if Tasks  = Nil then TaskError(teNotInit);
     if TaskAct <> 1 then TaskError(teStopFromSub);
     if ID     =   0 then TaskError(teStopMain);
     i:= 1;  While (i<=TaskNum) and (Tasks^[i].ID <> ID) do Inc(i);
     if i > TaskNum  then TaskError(teIDNotFound);  TaskRemove(i);
     TaskLeave;
end;

Procedure TaskFreeze;
begin
     TaskEnter;  SetIntVec(NumTimer,OldTimer);     SetTimerDefault;
     TaskLeave
end;

Procedure TaskMelt;
begin
     TaskEnter;  SetIntVec(NumTimer,@Dispatcher);  SetTimer(TaskFreq);
     TaskLeave
end;


Function GetTaskNum:TTaskInd;
begin
     TaskEnter;
     if Tasks = Nil then TaskError(teNotInit);
     GetTaskNum:= TaskNum;
     TaskLeave
end;

Function GetTaskID:TTaskID;
begin
     TaskEnter;
     if Tasks = Nil then TaskError(teNotInit);
     GetTaskID:= Tasks^[TaskAct].ID;
     TaskLeave
end;

Begin
     {$IfDef DEBUG}  SetIntVec(NumTimer,@NullInt);
     {$EndIf}        Tasks:= Nil;
End.
